/** \file DXInfo.h
<h2> Reads & displays system information </h2> <br>
Copyright (C) 2011 Xi Chen <br>

-------------------------------------------------------------------------<br>
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version. <br>

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. <br>

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. <br>
-------------------------------------------------------------------------<br>

\brief Reads & displays system information
\author Xi Chen hypernewbie@gmail.com
\date 15/11/2011

*/

#ifndef __DX_INFO__
#define __DX_INFO__

#include "DXInterface.h"

//! Prints to the console ( wInfo() ) information about the current
//  system, and the system's DirectX capabilities and limitations
void dxDisplayInfo();

//! Returns the maximum number of vertices that the current system
//  allows to be sent in a single DrawPrimitive() call.
unsigned int dxMaxPrimCount();

#endif