/** \file DXIntegrate.h
<h2> Contains integration utility functions </h2> <br>
Copyright (C) 2011 Xi Chen <br>

-------------------------------------------------------------------------<br>
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version. <br>

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. <br>

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. <br>
-------------------------------------------------------------------------<br>

\brief Contains integration utility functions
\author Xi Chen hypernewbie@gmail.com
\date 15/11/2011

*/

#ifndef __DX_INTEGRATION__
#define __DX_INTEGRATION__

#include "DXInterface.h"

#define DX_INTEGRATION_GLOBAL_TIMESCALE 1.0f

//! Integrate the velocity with respect to
//  global frame time using simple Euler method.
inline float eulerIntegrate( float dt ) {
    return frameTime * dt * DX_INTEGRATION_GLOBAL_TIMESCALE;
}

#endif
