/** \file SceneTunnel.h
<h2> Cube Tunnel Scene </h2> <br>
Copyright (C) 2011 Xi Chen <br>

-------------------------------------------------------------------------<br>
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version. <br>

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. <br>

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. <br>
-------------------------------------------------------------------------<br>

\brief Cube Tunnel Scene
\author Xi Chen hypernewbie@gmail.com
\date 15/11/2011

*/

#ifndef __SCENE_CUBE_TUNNEL_H__
#define __SCENE_CUBE_TUNNEL_H__

#include "Scene.h"

#define SCENE_CUBETUNNEL_SHADERFILE "CubeTunnel/cubeTunnelShader.fx"
#define SCENE_CUBETUNNEL_RINGSHADERFILE "CubeTunnel/ringShader.fx"
#define SCENE_CUBETUNNEL_RINGTEXTURE "CubeTunnel/tunnelRing.jpg"
#define SCENE_CUBETUNNEL_RINGTEXTURE2 "CubeTunnel/tunnelRing2.jpg"

class SceneCubeTunnel : public Scene {

    Shader cubeTunnelShader;
    ShaderGlobalSemantics *sgs;
    const char* currentTechnique;

    dxPrimitivesObj *ring;
    Shader ringShader;
    TextureArray cubeTunnelTextures;

public:
    void load();
    void render(ShaderGlobalSemantics &shaderSem, D3DXMATRIX &matView, D3DXMATRIX &matProjection);
    void update( D3DXMATRIX &matView, ShaderGlobalSemantics *shaderSem );
    void release();

protected:

    void renderTunnelCube( float start, float end, float radius, float rot,
                           float scaleX = 4.0, float scaleY = 0.25, float scaleZ = 1.0 );

    void renderTunnel( int seed, int density, float start, float end, float radius, float rot,
                       float scaleX = 4.0, float scaleY = 0.25, float scaleZ = 2.0 );

};

#endif