/** \file Process.cpp
<h2> Message Process Module </h2> <br>
Copyright (C) 2011 Xi Chen <br>

-------------------------------------------------------------------------<br>
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version. <br>

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. <br>

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. <br>
-------------------------------------------------------------------------<br>

\brief Handles and processes Win32 messages
\author Xi Chen hypernewbie@gmail.com
\date 15/11/2011

*/


#ifndef WINVER          // Allow use of features specific to Windows 95 and Windows NT 4 or later.
#define WINVER 0x0501
#endif
#ifndef _WIN32_WINNT    // Allow use of features specific to Windows NT 4 or later.
#define _WIN32_WINNT 0x0501 
#endif                       
#ifndef _WIN32_WINDOWS  // Allow use of features specific to Windows 98 or later.
#define _WIN32_WINDOWS 0x0501
#endif

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <windows.h>
#include <windowsx.h>
#include <d3d9.h>
#include <d3dx9.h>
#include "EngineHeader/DXInterface.h"

//! Win32 Callback function that handles and processes incoming window messages
LRESULT CALLBACK windowProcessMessages(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam) {
    switch(message) {
        case WM_SIZE:
            if( d3dDevice != NULL && wParam != SIZE_MINIMIZED ) {
                /*d3dpp.BackBufferWidth  = d3dWindowWidth = LOWORD(lParam);
                d3dpp.BackBufferHeight  = d3dWindowHeight = HIWORD(lParam);
                HRESULT ret = d3dDevice->Reset( &d3dpp );
                if( ret == D3DERR_INVALIDCALL ) { wError("Window Resize: Reset() fail"); return 0;}
                dxReloadState();*/
                //D3DVIEWPORT9 viewPort;
                //d3dDevice->GetViewport( &viewPort );
                //viewPort.Width = d3dWindowWidth = LOWORD(lParam);
                //viewPort.Height = d3dWindowHeight = HIWORD(lParam);
                //d3dDevice->SetViewport( &viewPort );
            }
            break;
        case WM_SYSCOMMAND: if(wParam == SC_SCREENSAVE) return 0; break;
        case WM_KEYDOWN: key[wParam] = true; wiKey( wParam ); break;
        case WM_KEYUP: key[wParam] = false; break;
        case WM_MOUSEWHEEL: wiMouseWheel( ((signed short)HIWORD(wParam)) / WHEEL_DELTA ); break;
        case WM_MOUSEMOVE: wiMouseMove( GET_X_LPARAM(lParam), GET_Y_LPARAM(lParam) ); break;
        case WM_LBUTTONDOWN: leftMouse = true; break;
        case WM_RBUTTONDOWN: rightMouse = true; break;
        case WM_LBUTTONUP: leftMouse = false; break;
        case WM_RBUTTONUP: rightMouse = false; break;
        case WM_DESTROY:
            PostQuitMessage(0);
            return 0;
    }
    return DefWindowProc (hWnd, message, wParam, lParam);
}